;!function(){try{var k="_btDebugIds",u="undefined",v="ec522983-ac4e-351c-2341-73f3a3d313ab",a=function(x){try{x[k]=x[k]||{};x[k][n]=v}catch{}},n=(new Error).stack;n&&(u!=typeof window?a(window):u);n&&(u!=typeof global?a(global):u);n&&(u!=typeof self?a(self):u);n&&(u!=typeof globalThis?a(globalThis):u)}catch{}}();
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const backtrace_service_1 = require("backtrace-service");
const errors_1 = require("../lib/errors");
const util_1 = require("../lib/util");
const repoRulesController = (db, service, urlPrefix) => {
    service.app.get(`${urlPrefix}/:universeName/:projectName/rules`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, backtrace_service_1.asyncWrapper)(async (req, res, _next) => {
        const projectName = req.params.projectName;
        const universeName = req.params.universeName;
        let rules;
        rules = await db("rules")
            .select("*")
            .where("project_name", projectName)
            .where("universe_name", universeName);
        return res.send({ rules });
    }));
    service.app.put(`${urlPrefix}/:universeName/:projectName/rules/:id`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, util_1.adminCheck)(service), (0, backtrace_service_1.asyncWrapper)(async (req, res, _next) => {
        const { project_name, universe_name, position, field_type, field_name, regex, } = req.body;
        const updateProps = {
            project_name,
            universe_name,
            position,
            field_type,
            field_name,
            regex,
        };
        if (!Number.isInteger(position)) {
            return res.status(422).send((0, errors_1.getError)(9, "Position not specified"));
        }
        const { projectName, universeName, id } = req.params;
        const rule = await db("rules").first("*").where({
            universe_name: universeName,
            project_name: projectName,
            id,
        });
        if (!rule) {
            return res
                .status(404)
                .send((0, errors_1.getError)(4, `Rule with id ${id} not found`));
        }
        const origPos = rule.position;
        const newPos = position;
        await (0, util_1.updatePosition)({
            db,
            origPos,
            newPos,
            rowId: rule.id,
            tableName: "rules",
            extendQueryCb: (q) => q
                .where("universe_name", rule.universe_name)
                .where("project_name", rule.project_name),
            trxCb: (trx) => trx("rules").first("*").where("id", id).update(updateProps),
        });
        const newRule = await db("rules").first("*").where("id", id);
        return res.send({ rule: newRule });
    }));
    service.app.post(`${urlPrefix}/:universeName/:projectName/rules`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, util_1.adminCheck)(service), (0, backtrace_service_1.asyncWrapper)(async (req, res, _next) => {
        const { project_name, universe_name, position, matching_repository_id, field_type, field_name, regex, action, } = req.body;
        const createProps = {
            project_name,
            universe_name,
            position,
            matching_repository_id,
            field_type,
            field_name,
            regex,
            action,
        };
        const newRule = await (0, util_1.createSpaceAtPosition)({
            db,
            pos: 0,
            tableName: "rules",
            extendQueryCb: (q) => q
                .where("universe_name", universe_name)
                .where("project_name", project_name),
            trxCb: (trx) => trx("rules").insert(createProps),
        });
        return res.send({ rule: newRule });
    }));
    service.app.delete(`${urlPrefix}/:universeName/:projectName/rules/:id`, service.identityManager.authenticateRequest(), (0, util_1.accessCheck)(service), (0, util_1.adminCheck)(service), (0, backtrace_service_1.asyncWrapper)(async (req, res, _next) => {
        const { projectName, universeName, id } = req.params;
        if (!Number.isInteger(parseInt(id, 10))) {
            return res.status(422).send((0, errors_1.getError)(2, "Invalid rule ID"));
        }
        const rule = await db("rules").first("position").where({
            universe_name: universeName,
            project_name: projectName,
            id,
        });
        if (!rule) {
            return res.status(404).send();
        }
        await db("rules").where("id", id).del();
        await db("rules")
            .where("position", ">", rule.position)
            .update({ position: db.raw(`\`position\` - 1`) });
        return res.status(200).send();
    }));
};
exports.default = repoRulesController;
//# sourceMappingURL=repo_rules.js.map
//# debugId=ec522983-ac4e-351c-2341-73f3a3d313ab