;!function(){try{var k="_btDebugIds",u="undefined",v="a4d514dd-ff29-2875-6307-7496e6b1f7a8",a=function(x){try{x[k]=x[k]||{};x[k][n]=v}catch{}},n=(new Error).stack;n&&(u!=typeof window?a(window):u);n&&(u!=typeof global?a(global):u);n&&(u!=typeof self?a(self):u);n&&(u!=typeof globalThis?a(globalThis):u)}catch{}}();
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deleteArchive = exports.addTarToArchive = exports.createArchiveRepo = exports.createArchiveDb = exports.createArchive = exports.rmAllFromGit = void 0;
const db_1 = __importDefault(require("../lib/db"));
const git_routines_1 = require("../lib/git_routines");
const fs = require("fs");
const path = require("path");
const backtrace_service_1 = require("backtrace-service");
const log = backtrace_service_1.Logger.getLogger();
const util_1 = require("../lib/util");
const crypto_1 = require("crypto");
const rimraf = __importStar(require("rimraf"));
async function createArchiveDb(data) {
    const archive_secret = (0, crypto_1.randomBytes)(32).toString("hex");
    const [id] = await (0, db_1.default)("repositories").insert(Object.assign(Object.assign({}, data), { archive_secret, url: "local_archive", auth_type: "none", clone_status: "complete" }));
    return id;
}
exports.createArchiveDb = createArchiveDb;
async function deleteArchiveDb(id) {
    await (0, db_1.default)("repositories").where("id", id).del();
}
async function createArchiveRepo(id) {
    const directory = (0, git_routines_1.repoPath)(id);
    fs.mkdirSync(directory, { recursive: true }, (err) => {
        if (err) {
            err.message = "createArchiveRepo: " + err.message;
            log.error(err);
        }
    });
    const out = await (0, git_routines_1.gitCmd)({
        args: ["init", "-b", "master", "."],
        cwd: directory,
        timeout: 3000,
        opts: { suppress_warnings: [/warning: templates not found/] },
    });
    if (!/Initialized empty Git repository/.test(out)) {
        throw "createArchiveRepo error: " + out;
    }
    return directory;
}
exports.createArchiveRepo = createArchiveRepo;
async function deleteArchiveRepo(id) {
    rimraf.sync(path.resolve((0, git_routines_1.repoPath)(id)));
}
async function createArchive({ universe_name, project_name, name, default_commit, }) {
    const id = await createArchiveDb({
        universe_name,
        project_name,
        name,
        default_commit,
    });
    const archPath = await createArchiveRepo(id);
    const archive = await (0, db_1.default)("repositories").first("*").where("id", id);
    return { archive, archivePath: archPath };
}
exports.createArchive = createArchive;
async function deleteArchive(id) {
    await deleteArchiveDb(id);
    await deleteArchiveRepo(id);
}
exports.deleteArchive = deleteArchive;
async function addTarToArchive(filePath, tag, id) {
    const archPath = (0, git_routines_1.repoPath)(id);
    await rmAllFromGit(archPath);
    (0, util_1.decompress)(filePath, archPath);
    await (0, git_routines_1.gitCmd)({ args: ["add", "."], cwd: archPath, timeout: 3000 });
    await (0, git_routines_1.gitCmd)({
        args: ["commit", "-m", tag],
        cwd: archPath,
        timeout: 3000,
    });
    await (0, git_routines_1.gitCmd)({ args: ["tag", `'${tag}'`], cwd: archPath, timeout: 3000 });
    return await (0, git_routines_1.gitCmd)({
        args: ["rev-parse", "HEAD"],
        cwd: archPath,
        timeout: 3000,
    });
}
exports.addTarToArchive = addTarToArchive;
async function rmAllFromGit(repoPath) {
    if (fs.existsSync(path.resolve(repoPath, ".git"))) {
        rimraf.sync(path.resolve(repoPath, "*"));
    }
}
exports.rmAllFromGit = rmAllFromGit;
//# sourceMappingURL=archive.js.map
//# debugId=a4d514dd-ff29-2875-6307-7496e6b1f7a8