
exports.up = function(knex) {
  return knex.schema.createTable('perforce_servers', function(t) {
    t.increments('id')
      .unsigned()
      .primary()
      .defaultTo(1);
    t.integer('universe_name').notNullable();
    t.integer('project_name').notNullable();
    t.index(['universe_name', 'project_name']);

    t.string('name').notNullable();
    t.string('host').notNullable();
    t.integer('port').notNullable();
    t.string('user_name').notNullable();
    t.string('password');

    t.string('default_depot_path');

    t.enu('connection_status', ['working', 'not_working']).notNullable();
    t.text('error');
    t.timestamps(false, true);
  });
};

exports.down = function(knex) {
  return knex.schema.dropTable('perforce_servers');
};
