
exports.up = function(knex) {
  return knex.schema.dropTable('archives');
};

exports.down = function(knex) {
  return knex.schema.createTable('archives', function(t) {
    t.increments('id')
      .unsigned()
      .primary()
      .defaultTo(1);
    t.integer('project_name').notNullable();
    t.integer('universe_name').notNullable();
    t.string('name').notNullable();
    t.string('secret').notNullable();
    t.timestamps(false, true);
    t.index(['universe_name','project_name']);
  });
};
