export declare class ErrorHelper {
    /**
     * Generate an error message based on the error type. If the error
     * is not an error, then will use the default error message.
     * @param error Error object
     * @param defaultMessage default error message if the error object is not an error
     * @returns error message
     */
    static getErrorMessage(error: unknown, defaultMessage?: string): string;
    /**
     * Retrieves status code based on the error object and possible axios response.
     * @param error Error object
     * @param defaultStatusCode default status code
     * @returns status code
     */
    static getErrorStatusCode(error: unknown, defaultStatusCode?: number): number;
}
